/*
 * ULeval.java
 */
 
import java.util.Enumeration;

class ULeval extends ULisph {
    
    public static void eval() {
	
    debut_eval:
	for(;;) {
	    if(is_int(a0)) return;
	    if(is_at(a0)) {
		if(cval(a0) == undefined)
		    err("Atome " + ((Atom) a0).pname + ", valeur indefinie");
		a0 = cval(a0); return;
	    }
	    a4 = car(a0);
	    
	evalcar:
	    for(;;) {
		if(is_int(a4))
		    err("Nombre en position fonctionnelle " + val_int(a4));
		if(is_at(a4))
		    switch(((Atom) a4).fval) {
		    case 3: // quote
			a0 = cadr(a0); return;
		    case 5: // car
			eval_1_arg(); a0 = car(a0); return;
		    case 6: // cdr
			eval_1_arg(); a0 = cdr(a0); return;
		    case 7: // add1
			eval_1_arg(); a0 = make_int(val_int(a0) + 1);
			return;
		    case 8: // sub1
			eval_1_arg(); a0 = make_int(val_int(a0) - 1);
			return;
		    case 9: // defun
			a0 = cdr(a0); a1 = car(a0);
			setcval(a1, cons(lambda, cdr(a0)));
			a0 = a1; return;
		    case 10: // print
			eval_1_arg();
			ULprint.obj_print(a0); System.out.println("");
			return;
		    case 11: // setq
			push(cadr(a0)); a0 = cadr(cdr(a0)); eval(); a1 = pop();
			setcval(a1, a0); return;
		    case 12: // eq
			eval_2_args();
			if(is_int(a1) && is_int(a0))
			    a0 = val_int(a1) == val_int(a0) ? t : nil;
			else
			    a0 = a1 == a0 ? t : nil;
			return;
		    case 13: // if
			push(a0); a0 = cadr(a0); eval(); a1 = pop();
			a0 = (a0 == nil) ? cadr(cddr(a1)) : cadr(cdr(a1));
			continue debut_eval;
		    case 14: // times
			eval_2_args();
			a0 = make_int(val_int(a1) * val_int(a0));
			return;
		    case 15: // oblist
			a0 = nil;
			for(Enumeration e = Lhashtable.keys(); e.hasMoreElements();)
			    a0 = cons(((Object) Lhashtable.get(e.nextElement())), a0);
			return;
		    case 16: // cons
			eval_2_args();
			a0 = cons(a1, a0);
			return;
		    case 17: // plus
			eval_2_args();
			a0 = make_int(val_int(a0) + val_int(a1));
			return;
		    case 18: // less
			eval_2_args();
			a0 = val_int(a1) < val_int(a0) ? t : nil;
			return;
		    case 19: // minus
			eval_2_args();
			a0 = make_int(val_int(a0) - val_int(a1));
			return;
		    case 20: // div
			eval_2_args();
			a0 = make_int(val_int(a0) / val_int(a1));
			return;
		    case 21: // caar
			eval_1_arg(); a0 = caar(a0); return;
		    case 22: // cadr
			eval_1_arg(); a0 = cadr(a0); return;
		    case 23: // cdar
			eval_1_arg(); a0 = cdar(a0); return;
		    case 24: // cddr
			eval_1_arg(); a0 = cddr(a0); return;
		    case 25: // last : dernier element de la liste
		    	eval_1_arg();
		    	while (cdr(a0) != nil) a0 = cdr(a0);
		    	a0 = car(a0);
		    	return;
		    case 26: // butlast : liste sans le dernier element
		    	eval_1_arg();
		    	a1 = a0; // a1 : registre de travail
		    	if (cdr(a1) == nil){
		    		setcar(a1, nil);
		    		return;
		    	}
		    	while(cddr(a1) != nil) a1 = cdr(a1);
		    	setcdr(a1, nil);
		    	return;
		    case 27: // middle
		    	eval_1_arg();
		    	a1 = a0;
		    	if (cdr(a1) == nil){
		    		setcar(a1, nil);
		    		return;
		    	}
		    	while(cddr(a1) != nil) a1 = cdr(a1);
		    	setcdr(a1, nil);
		    	a0 = cdr(a0);
		    	return;
		    case 28: // max
		    	eval_2_args();
		    	if(val_int(a0) < val_int(a1)) a0 = a1;
		    	return;
		    case 29: // min
		    	eval_2_args();
		    	if(val_int(a0) > val_int(a1)) a0 = a1;
		    	return;
		    case 30: // square
		    	eval_1_arg();
		    	a0 = make_int(val_int(a0) * val_int(a0));
		    	return;
		    case 31: // half
		    	return;
		    // examen du premier MODULE
		    case 32: // length
		    	int length = 0;
		    	eval_1_arg();
		    	if(a0 == nil){ // si liste vide
		    		a0 = make_int(length);
		    		return;
		    	}
		    	while(cdr(a0) != nil){
		    		length++;
		    		a0 = cdr(a0);
		    	}
		    	a0 = make_int(++length);	
		    	return;
		    case 33: // ncons
		    	eval_2_args();
		    	if(a0 == nil){ // si 1ere liste vide
		    		a0 = a1;
		    		return;
		    	}
		    	a2 = a0;
		    	while(cdr(a2) != nil) a2 = cdr(a2);
		    	setcdr(a2,a1);
		    	return;
		    case 34: // delq
		    	eval_2_args();
		    	while(val_int(car(a1)) == val_int(a0)){ //si en tete de liste
		    		 if(cdr(a1) == nil){
		    		 	a0 = nil;
		    		 	return;
		    		 }
		    		 a1 = cdr(a1); 
		    	}
		    	a2 = a1; // sauvegarde du debut
		    	while(cdr(a2) != nil){
		    		if(val_int(cadr(a2)) == val_int(a0)){
		    			if(cddr(a2) == nil){
		    				setcdr(a2, nil);
		    				return;
		    			}
		    			setcdr(a2, cddr(a2));
		    		}
		    		else a2 = cdr(a2); // seulement si pas le delq
		    	}
		    	a0 = a1;
		    	return;
		    case 35: // equalp
		    	eval_2_args();
		    	if ((a0 == nil) || (a1 == nil)){ // si liste(s) vide(s)
		    		a0 = a0 == a1 ? t : nil;
		    		return;
		    	}
		    	while(car(a0) == car(a1)){
		    		if((cdr(a0) == nil) || (cdr(a1) == nil)){ // si listes != tailles
		    			a0 = cdr(a0) == cdr(a1) ? t : nil;
		    			return;
		    		}			    		
		    		a0 = cdr(a0);
		    		a1 = cdr(a1);
		    	}
		    	return;
		    case 36: // nth
		    	int nth;
		    	eval_2_args();
		    	if (a0 == nil) return; // liste vide : nil
		    	if (val_int(a1) == 0){ // le 0eme : nil
		    		a0 = nil;
		    		return;
		    	}
		    	for(nth = 1; nth < val_int(a1); nth++){
		    		if(cdr(a0) == nil){ // si pas de Neme : nil
		    			a0 = nil;
		    			return;
		    		}
		    		a0 = cdr(a0);
		    	}		
		    	a0 = car(a0);
		    	return;
		    case 37: // midelt
		    	eval_1_arg();
		    	a1 = a0;
		    	while(cdr(a1) != nil){
		    		if(cddr(a1) == nil){ // si paire : nil
		    			a0 = nil;
		    			return;
		    		}
		    		a1 = cddr(a1);
		    		a0 = cdr(a0);
		    	}
		    	a0 = car(a0);
		    	return;
		    case 38: // poly
			eval_2_args () ;
			int puiss = 0 ; int temp = 0 ;
			while (a1 != nil) {
			    temp += (val_int(car (a1)) * power (val_int(a0), puiss++));
			    a1 = cdr (a1) ;
			}
			a0 = make_int(temp);
			return;
		    case 39: // val
			eval_2_args();
			while(a1 != nil){
			    if(caar(a1) == a0){
				a0 = car(cdar(a1));
				return;
			    }
			    else 
				a1 = cdr(a1);
			}
			a0 = nil;
		    	return;
		    case 40: // max3
		    	eval_3_args();
		    	if(val_int(a0) < val_int(a1))
				a0 = val_int(a1) < val_int(a2) ? a2 : a1;
			else
				a0 = val_int(a0) < val_int(a2) ? a2 : a0;   	
		    	return;
		    case 41: // listadd
		    	eval_1_arg();
		    	a1 = make_int(val_int(car(a0)));
		    	while(cdr(a0) != nil){
		    		a0 = cdr(a0);
		    		a1 = make_int(val_int(a1) + val_int(car(a0)));
		    	}
		    	a0 = a1;
		    	return;
		    case 42: // mconc 
		    	eval_1_arg();
		    	a1 = car(a0);
			a2 = a1;
			while(a0 != nil){
				while(cdr(a1) != nil)
					a1 = cdr(a1);
				a0 = cdr(a0);
				setcdr(a1, caar(a0));
			}
			a0 = a2;
		    	return;
		    case 43: // decimetre
		    	eval_1_arg();
			a1 = a0 ;
			while (cdr(a1) != nil) {
			    if(cddr(a1) == nil){
				setcdr(a1, nil);
				return;
			    }
			    setcdr(a1, cddr(a1));
			    a1 = cdr(a1);
			}
		    	return;
		    default:
			if(cval(a4) == undefined) break debut_eval;
			a4 = cval(a4); continue evalcar;
		    }
		
		if(car(a4) == lambda) {
		    push(a4); push(a2); push(a0);
		    a0 = cdr(a0);
		    evlis();
		    a1 = a0;
		    a0 = pop(); a2 = pop(); a4 = pop();
		    bind(cadr(a4), a1);
		    a0 = cddr(a4);
		    progn();
		    unbind();
		    return;
		}
	    }
	}    
	err("Fonction inconnue " + ((Atom) a4).pname);
    }
    
    public static int power (int a, int b) {
	int resultat = 1 ;
	if (a == 0) return (0);
	for (int i = b; i > 0; i--) {
	    resultat *= a ;
	}
	return resultat ;
    }

    public static void eval_1_arg() {
	a0 = cadr(a0); eval();
    }
    
    // fonction eval_2_args() revue et corrigee
    public static void eval_2_args() {
    	push(a0); a0 = cadr(cdr(a0)); eval();
    	a1 = a0; a0 = pop();
    	a0 = cadr(a0); eval();
    }
    
    // fonction eval_3_args() 
    public static void eval_3_args() {
    	push(a0); a0 = cadr(cddr(a0)); eval();
    	a2 = a0; a0 = pop();
    	push(a0); a0 =cadr(cdr(a0)); eval();
    	a1 = a0; a0 = pop();
    	a0 = cadr(a0); eval();
    }
    
    public static void progn() {
	a1 = a0;
	while(a1 != nil) {
	    push(a1); a0 = car(a1); eval(); a1 = pop(); a1 = cdr(a1);
	}
    }

    public static void evlis() {
	a4 = a2 = cons(nil, nil); push(a4);
	while(a0 != nil) {
	    push(a0); push(a2); a0 = car(a0); eval();
	    a2 = pop(); setcdr(a2, cons(a0, nil)); a2 = cdr(a2);
	    a0 = pop(); a0 = cdr(a0);
	}
	a4 = pop(); a0 = cdr(a4);
    }
    
    public static void bind(Object x, Object y) {
	Object z = x;
	
	push(undefined);
	while(z != nil) {
	    push(cval(car(z))); push(car(z)); z = cdr(z);
	}
	while(x != nil) {
	    setcval(car(x), car(y)); x = cdr(x); y = cdr(y);
	}
    }
    
    public static void unbind() {
	Object x, y;
	
	for(;;) {
	    x = pop(); if(x == undefined) return;
	    y = pop(); setcval(x, y);
	}
    }
}
