/*
 * ULisph.java
 */

import java.util.Hashtable;
import java.util.Stack;

class ULisph {
    
    public static Object car(Object x) {return(((Cons) x).car);}
    public static Object cdr(Object x) {return(((Cons) x).cdr);}
    public static void setcar(Object x, Object e) {((Cons) x).car = e;}
    public static void setcdr(Object x, Object e) {((Cons) x).cdr = e;}

    public static Object caar(Object x) {return(car(car(x)));}
    public static Object cadr(Object x) {return(car(cdr(x)));}
    public static Object cdar(Object x) {return(cdr(car(x)));}
    public static Object cddr(Object x) {return(cdr(cdr(x)));}

    public static Object cval(Object x) {return(((Atom) x).cval);}
    public static void setcval(Object x, Object e) {((Atom) x).cval =e;}
    
    public static boolean is_at(Object x) {return (x instanceof Atom);}
    public static boolean is_cons(Object x) {return (x instanceof Cons);}
    public static boolean is_int(Object x) {return (x instanceof Integer);}

    static Object a0, a1, a2, a3, a4;
    static Object nil, undefined, t, quote, lambda;
    
    static String [] p_temp_names = {"car", "cdr", "add1", "sub1", "defun",
				     "print", "setq", "eq", "if", "times",
				     "oblist", "cons", "plus", "less",
				     "minus", "div", "caar", "cadr", "cdar",
				     "cddr", "last", "butlast", "middle",
				     "max", "min", "square", "half",
				     "length", "ncons", "delq", "equalp",
				     "nth", "midelt", "poly", "val",
				     "max3", "listadd", "mconc", "decimetre"};
    
    public static Object make_int(int x) {return(new Integer(x));}
    public static int val_int(Object x) {return(((Integer) x).intValue());}
    
    public static Object cons(Object x, Object y) {return(new Cons(x, y));}
    
    static Hashtable Lhashtable = new Hashtable();

    public static Object cratom(String pname) {
	Object res = (Object) new Atom(pname); Lhashtable.put(pname, res);
	return (res);
    }

    static Stack Lstack = new Stack();
    public static void push(Object x) {Lstack.push(x);}
    public static Object pop() {return(Lstack.pop());}

    public static void err(String s) {ULisp.err(s);}
}

class Cons {
    
    Object car, cdr;
    
    public Cons(Object car, Object cdr) {this.car = car; this.cdr = cdr;}
}

class Atom {

    static int id = 0;
    String pname; Object cval; int fval;

    public Atom(String pname) {
	this.pname = pname; cval = ULisph.undefined; fval = id++;
    }
}
